%if 0%{?suse_version}
%define repo_path %_sysconfdir/zypp/repos.d
%define system sles
%else
%define repo_path %_sysconfdir/yum.repos.d
%define system centos
%endif

%define op5_major %(echo %{version}|cut -d"." -f 1)
%define op5_prev_version %(let "m = %{op5_major} - 1"; echo $m)
%define op5_next_version %(let "m = %{op5_major} + 1"; echo $m)
%define op5_minor %(echo %{version}|cut -d"." -f 2)

Summary: op5 release and package configuration.
Name: op5-release
Version: %{op5version}
Release: %{op5release}%{?dist}
Group: op5/System-Addons
License: op5 Software License
Prefix: %repo_path
Source0: %name-%version.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}
BuildArch: noarch
%if 0%{?suse_version}
BuildRequires: libzypp
%endif
Obsoletes: op5-monitor-repo-config <= 1:%version
Obsoletes: op5-system-addons < 1:6.6
Obsoletes: op5-system-release-addons <= 1:%version
Obsoletes: op5-release-up-%op5_prev_version-to-%op5_major < %version
Provides: op5-system-addons = 1:%version
Provides: op5-system-release-addons = 1:%version

%description
%name contains the op5 repository configuration.

%package head
Group: op5/System-Addons
Summary: op5 development repository configuration UNSTABLE!
Requires: op5-release

%description head
op5 repository configuration that contains normally unsupported packages.
These repositories are disabled by default, so installing this package and
running a yum update will not automatically install unstable packages onto
your system.

%package public-beta
Group: op5/System-Addons
Summary: op5 beta repository configuration for proposed bugfix packages
Requires: op5-release
Obsoletes: op5-epel-beta-repo-config < %version
Obsoletes: op5-monitor-beta-repo-config < %version
Obsoletes: op5-system-beta-repo-config < %version

%description public-beta
op5 repository configuration that contains normally unsupported packages.
These repositories are disabled by default, so installing this package and
running a yum update will not automatically install unstable packages onto
your system.

%package stage
Group: op5/System-Addons
Summary: op5 staging repository configuration for the next minor release
Requires: op5-release

%description stage
op5 repository configuration that contains normally unsupported packages.
These repositories are disabled by default, so installing this package and
running a yum update will not automatically install unstable packages onto
your system.

%package next-head
Group: op5/System-Addons
Summary: op5 development repository configuration UNSTABLE!
Requires: op5-release

%description next-head
op5 repository configuration that contains normally unsupported packages.
These repositories are disabled by default, so installing this package and
running a yum update will not automatically install unstable packages onto
your system.

%package next-public-beta
Group: op5/System-Addons
Summary: op5 beta repository configuration for proposed bugfix packages
Requires: op5-release

%description next-public-beta
op5 repository configuration that contains normally unsupported packages.
These repositories are disabled by default, so installing this package and
running a yum update will not automatically install unstable packages onto
your system.

%package next-stage
Group: op5/System-Addons
Summary: op5 staging repository configuration for the next release
Requires: op5-release

%description next-stage
op5 repository configuration that contains normally unsupported packages.
These repositories are disabled by default, so installing this package and
running a yum update will not automatically install unstable packages onto
your system.

%package up-%op5_major-to-%op5_next_version
Group: op5/System-Addons
Summary: op5 upgrade repository configuration for the next release
Requires: op5-release

%description up-%op5_major-to-%op5_next_version
op5 repository configuration that contains repository config to upgrade
to next version of op5 Monitor

%prep
%setup -q

%build

%install
rm -rf %buildroot
mkdir %buildroot

mkdir -p %buildroot/%repo_path
mkdir -p %buildroot/%_sysconfdir/pki/rpm-gpg

# Install stable repo files
install -m 644 RPM-GPG-KEY-op5  %buildroot/%_sysconfdir/pki/rpm-gpg
install -m 664 op5-release.repo.%system %buildroot/%repo_path/op5-release.repo
install -m 664 op5-release-debuginfo.repo.%system %buildroot/%repo_path/op5-release-debuginfo.repo
install -m 664 op5-release-source.repo.%system %buildroot/%repo_path/op5-release-source.repo

# Install up-<version>-to-<version> repo files
install -m 664 op5-release.repo.%system %buildroot/%repo_path/op5-release-up-%op5_major-to-%op5_next_version.repo
install -m 664 op5-release-debuginfo.repo.%system %buildroot/%repo_path/op5-release-debuginfo-up-%op5_major-to-%op5_next_version.repo
install -m 664 op5-release-source.repo.%system %buildroot/%repo_path/op5-release-source-up-%op5_major-to-%op5_next_version.repo

# Fix the name and paths in the stable repo files
sed -i "s/@@STABILITY_NAME@@[-/ ]//g" %buildroot/%repo_path/op5-release.repo
sed -i "s/@@STABILITY_NAME@@[-/ ]//g" %buildroot/%repo_path/op5-release-{debuginfo,source}.repo
sed -i "s/@@STABILITY_URL@@[-/ ]//g" %buildroot/%repo_path/op5-release.repo
sed -i "s/@@STABILITY_URL@@[-/ ]//g" %buildroot/%repo_path/op5-release-{debuginfo,source}.repo
sed -i "s/@@OP5_VERSION@@/%{op5_major}/" %buildroot/%repo_path/op5-release.repo
sed -i "s/@@OP5_VERSION@@/%{op5_major}/" %buildroot/%repo_path/op5-release-{debuginfo,source}.repo
sed -i "s/enabled=0/enabled=1/g" %buildroot/%repo_path/op5-release.repo


# Fix the name and paths in the up-<version>-to-<version> repo files
sed -i "s/@@STABILITY_NAME@@[-]/up-%op5_major-to-%op5_next_version-/g" %buildroot/%repo_path/op5-release-up-%op5_major-to-%op5_next_version.repo
sed -i "s/@@STABILITY_NAME@@[-]/up-%op5_major-to-%op5_next_version-/g" %buildroot/%repo_path/op5-release-{debuginfo,source}-up-%op5_major-to-%op5_next_version.repo
sed -i "s/@@STABILITY_NAME@@[ ]/up-%op5_major-to-%op5_next_version /g" %buildroot/%repo_path/op5-release-up-%op5_major-to-%op5_next_version.repo
sed -i "s/@@STABILITY_NAME@@[ ]/up-%op5_major-to-%op5_next_version /g" %buildroot/%repo_path/op5-release-{debuginfo,source}-up-%op5_major-to-%op5_next_version.repo
sed -i "s/@@STABILITY_URL@@//g" %buildroot/%repo_path/op5-release-up-%op5_major-to-%op5_next_version.repo
sed -i "s/@@STABILITY_URL@@//g" %buildroot/%repo_path/op5-release-{debuginfo,source}-up-%op5_major-to-%op5_next_version.repo
sed -i "s/@@OP5_VERSION@@/%{op5_next_version}/" %buildroot/%repo_path/op5-release-up-%op5_major-to-%op5_next_version.repo
sed -i "s/@@OP5_VERSION@@/%{op5_next_version}/" %buildroot/%repo_path/op5-release-{debuginfo,source}-up-%op5_major-to-%op5_next_version.repo

for stability in head public_beta stage; do
	install -m 664 op5-release.repo.%system %buildroot/%repo_path/op5-release-next-${stability}.repo
	install -m 664 op5-release-debuginfo.repo.%system %buildroot/%repo_path/op5-release-next-${stability}-debuginfo.repo
	install -m 664 op5-release-source.repo.%system %buildroot/%repo_path/op5-release-next-${stability}-source.repo
	sed -i "s/@@STABILITY_NAME@@[-]/next-${stability}-/g" %buildroot/%repo_path/op5-release-next-${stability}*
	sed -i "s/@@STABILITY_NAME@@[ ]/next-${stability} /g" %buildroot/%repo_path/op5-release-next-${stability}*
	sed -i "s/@@STABILITY_URL@@/${stability}/g" %buildroot/%repo_path/op5-release-next-${stability}*
	sed -i "s/@@OP5_VERSION@@/%{op5_major}/g" %buildroot/%repo_path/op5-release-next-${stability}*

	install -m 664 op5-release.repo.%system %buildroot/%repo_path/op5-release-${stability}.repo
	install -m 664 op5-release-debuginfo.repo.%system %buildroot/%repo_path/op5-release-${stability}-debuginfo.repo
	install -m 664 op5-release-source.repo.%system %buildroot/%repo_path/op5-release-${stability}-source.repo
	sed -i "s/@@STABILITY_NAME@@/${stability}/g" %buildroot/%repo_path/op5-release-${stability}*
	sed -i "s/@@STABILITY_URL@@/${stability}/g" %buildroot/%repo_path/op5-release-${stability}*
	sed -i "s/@@OP5_VERSION@@/%{op5_major}.%{op5_minor}/g" %buildroot/%repo_path/op5-release-${stability}*
done

install -m 644 op5-release %buildroot%_sysconfdir/op5-release

if [ %release == "op5.1" ]; then
  echo "VERSION=%version" > %buildroot%_sysconfdir/op5-release
else
  echo "VERSION=%version-%release" > %buildroot%_sysconfdir/op5-release
fi

%files
%defattr(-, root, root)
%repo_path/op5-release.repo
%repo_path/op5-release-debuginfo.repo
%repo_path/op5-release-source.repo
%_sysconfdir/op5-release
%_sysconfdir/pki/rpm-gpg/RPM-GPG-KEY-op5
%exclude %repo_path/op5-release-head.repo
%exclude %repo_path/op5-release-public_beta.repo
%exclude %repo_path/op5-release-stage.repo
%exclude %repo_path/op5-release-next-head.repo
%exclude %repo_path/op5-release-next-public_beta.repo
%exclude %repo_path/op5-release-next-stage.repo
%exclude %repo_path/op5-release-head-debuginfo.repo
%exclude %repo_path/op5-release-head-source.repo
%exclude %repo_path/op5-release-public_beta-debuginfo.repo
%exclude %repo_path/op5-release-public_beta-source.repo
%exclude %repo_path/op5-release-stage-debuginfo.repo
%exclude %repo_path/op5-release-stage-source.repo
%exclude %repo_path/op5-release-next-head-debuginfo.repo
%exclude %repo_path/op5-release-next-head-source.repo
%exclude %repo_path/op5-release-next-public_beta-debuginfo.repo
%exclude %repo_path/op5-release-next-public_beta-source.repo
%exclude %repo_path/op5-release-next-stage-debuginfo.repo
%exclude %repo_path/op5-release-next-stage-source.repo
%exclude %repo_path/op5-release-up-%op5_major-to-%op5_next_version.repo
%exclude %repo_path/op5-release-debuginfo-up-%op5_major-to-%op5_next_version.repo
%exclude %repo_path/op5-release-source-up-%op5_major-to-%op5_next_version.repo

%files head
%defattr(-,root,root)
%repo_path/op5-release-head.repo
%repo_path/op5-release-head-debuginfo.repo
%repo_path/op5-release-head-source.repo

%files stage
%defattr(-,root,root)
%repo_path/op5-release-stage.repo
%repo_path/op5-release-stage-debuginfo.repo
%repo_path/op5-release-stage-source.repo

%files public-beta
%defattr(-,root,root)
%repo_path/op5-release-public_beta.repo
%repo_path/op5-release-public_beta-debuginfo.repo
%repo_path/op5-release-public_beta-source.repo

%files next-head
%defattr(-,root,root)
%repo_path/op5-release-next-head.repo
%repo_path/op5-release-next-head-debuginfo.repo
%repo_path/op5-release-next-head-source.repo

%files next-stage
%defattr(-,root,root)
%repo_path/op5-release-next-stage.repo
%repo_path/op5-release-next-stage-debuginfo.repo
%repo_path/op5-release-next-stage-source.repo

%files next-public-beta
%defattr(-,root,root)
%repo_path/op5-release-next-public_beta.repo
%repo_path/op5-release-next-public_beta-debuginfo.repo
%repo_path/op5-release-next-public_beta-source.repo

%files up-%op5_major-to-%op5_next_version
%defattr(-, root, root)
%repo_path/op5-release-up-%op5_major-to-%op5_next_version.repo
%repo_path/op5-release-debuginfo-up-%op5_major-to-%op5_next_version.repo
%repo_path/op5-release-source-up-%op5_major-to-%op5_next_version.repo

%clean
rm -rf %buildroot

%changelog
* Sat Feb 8 2014 Mattias Ryrlén <mattiasr@op5.com>
- Initial creation
